"use strict";
/*!
 * Copyright (c) Microsoft Corporation and contributors. All rights reserved.
 * Licensed under the MIT License.
 */
Object.defineProperty(exports, "__esModule", { value: true });
exports.DetachedFieldIndex = exports.emptyDelta = exports.offsetDetachId = exports.makeDetachedNodeId = exports.isEmptyFieldChanges = exports.emptyFieldChanges = exports.deltaForSet = exports.deltaForRootInitialization = exports.getDescendant = exports.SparseNode = exports.makeDetachedFieldIndex = exports.combineVisitors = exports.applyDelta = exports.announceDelta = exports.visitDelta = exports.aboveRootPlaceholder = exports.rootField = exports.rootFieldKey = exports.keyAsDetachedField = exports.detachedFieldAsKey = exports.EmptyKey = exports.EncodedJsonableTree = exports.setGenericTreeField = exports.getGenericTreeField = exports.genericTreeKeys = exports.genericTreeDeleteIfEmpty = exports.getDetachedFieldContainingPath = exports.compareFieldUpPaths = exports.compareUpPaths = exports.getDepth = exports.topDownPath = exports.clonePath = exports.getMapTreeField = exports.isCursor = exports.CursorMarker = exports.inCursorNode = exports.inCursorField = exports.iterateCursorField = exports.forEachField = exports.forEachNodeInSubtree = exports.forEachNode = exports.mapCursorFields = exports.mapCursorField = exports.castCursorToSynchronous = exports.CursorLocationType = exports.anchorSlot = exports.AnchorSet = void 0;
var anchorSet_1 = require("./anchorSet");
Object.defineProperty(exports, "AnchorSet", { enumerable: true, get: function () { return anchorSet_1.AnchorSet; } });
Object.defineProperty(exports, "anchorSlot", { enumerable: true, get: function () { return anchorSet_1.anchorSlot; } });
var cursor_1 = require("./cursor");
Object.defineProperty(exports, "CursorLocationType", { enumerable: true, get: function () { return cursor_1.CursorLocationType; } });
Object.defineProperty(exports, "castCursorToSynchronous", { enumerable: true, get: function () { return cursor_1.castCursorToSynchronous; } });
Object.defineProperty(exports, "mapCursorField", { enumerable: true, get: function () { return cursor_1.mapCursorField; } });
Object.defineProperty(exports, "mapCursorFields", { enumerable: true, get: function () { return cursor_1.mapCursorFields; } });
Object.defineProperty(exports, "forEachNode", { enumerable: true, get: function () { return cursor_1.forEachNode; } });
Object.defineProperty(exports, "forEachNodeInSubtree", { enumerable: true, get: function () { return cursor_1.forEachNodeInSubtree; } });
Object.defineProperty(exports, "forEachField", { enumerable: true, get: function () { return cursor_1.forEachField; } });
Object.defineProperty(exports, "iterateCursorField", { enumerable: true, get: function () { return cursor_1.iterateCursorField; } });
Object.defineProperty(exports, "inCursorField", { enumerable: true, get: function () { return cursor_1.inCursorField; } });
Object.defineProperty(exports, "inCursorNode", { enumerable: true, get: function () { return cursor_1.inCursorNode; } });
Object.defineProperty(exports, "CursorMarker", { enumerable: true, get: function () { return cursor_1.CursorMarker; } });
Object.defineProperty(exports, "isCursor", { enumerable: true, get: function () { return cursor_1.isCursor; } });
var mapTree_1 = require("./mapTree");
Object.defineProperty(exports, "getMapTreeField", { enumerable: true, get: function () { return mapTree_1.getMapTreeField; } });
var pathTree_1 = require("./pathTree");
Object.defineProperty(exports, "clonePath", { enumerable: true, get: function () { return pathTree_1.clonePath; } });
Object.defineProperty(exports, "topDownPath", { enumerable: true, get: function () { return pathTree_1.topDownPath; } });
Object.defineProperty(exports, "getDepth", { enumerable: true, get: function () { return pathTree_1.getDepth; } });
Object.defineProperty(exports, "compareUpPaths", { enumerable: true, get: function () { return pathTree_1.compareUpPaths; } });
Object.defineProperty(exports, "compareFieldUpPaths", { enumerable: true, get: function () { return pathTree_1.compareFieldUpPaths; } });
Object.defineProperty(exports, "getDetachedFieldContainingPath", { enumerable: true, get: function () { return pathTree_1.getDetachedFieldContainingPath; } });
var treeTextFormat_1 = require("./treeTextFormat");
Object.defineProperty(exports, "genericTreeDeleteIfEmpty", { enumerable: true, get: function () { return treeTextFormat_1.genericTreeDeleteIfEmpty; } });
Object.defineProperty(exports, "genericTreeKeys", { enumerable: true, get: function () { return treeTextFormat_1.genericTreeKeys; } });
Object.defineProperty(exports, "getGenericTreeField", { enumerable: true, get: function () { return treeTextFormat_1.getGenericTreeField; } });
Object.defineProperty(exports, "setGenericTreeField", { enumerable: true, get: function () { return treeTextFormat_1.setGenericTreeField; } });
var persistedTreeTextFormat_1 = require("./persistedTreeTextFormat");
Object.defineProperty(exports, "EncodedJsonableTree", { enumerable: true, get: function () { return persistedTreeTextFormat_1.EncodedJsonableTree; } });
var types_1 = require("./types");
Object.defineProperty(exports, "EmptyKey", { enumerable: true, get: function () { return types_1.EmptyKey; } });
Object.defineProperty(exports, "detachedFieldAsKey", { enumerable: true, get: function () { return types_1.detachedFieldAsKey; } });
Object.defineProperty(exports, "keyAsDetachedField", { enumerable: true, get: function () { return types_1.keyAsDetachedField; } });
Object.defineProperty(exports, "rootFieldKey", { enumerable: true, get: function () { return types_1.rootFieldKey; } });
Object.defineProperty(exports, "rootField", { enumerable: true, get: function () { return types_1.rootField; } });
Object.defineProperty(exports, "aboveRootPlaceholder", { enumerable: true, get: function () { return types_1.aboveRootPlaceholder; } });
var visitDelta_1 = require("./visitDelta");
Object.defineProperty(exports, "visitDelta", { enumerable: true, get: function () { return visitDelta_1.visitDelta; } });
var visitorUtils_1 = require("./visitorUtils");
Object.defineProperty(exports, "announceDelta", { enumerable: true, get: function () { return visitorUtils_1.announceDelta; } });
Object.defineProperty(exports, "applyDelta", { enumerable: true, get: function () { return visitorUtils_1.applyDelta; } });
Object.defineProperty(exports, "combineVisitors", { enumerable: true, get: function () { return visitorUtils_1.combineVisitors; } });
Object.defineProperty(exports, "makeDetachedFieldIndex", { enumerable: true, get: function () { return visitorUtils_1.makeDetachedFieldIndex; } });
var sparseTree_1 = require("./sparseTree");
Object.defineProperty(exports, "SparseNode", { enumerable: true, get: function () { return sparseTree_1.SparseNode; } });
Object.defineProperty(exports, "getDescendant", { enumerable: true, get: function () { return sparseTree_1.getDescendant; } });
var deltaUtil_1 = require("./deltaUtil");
Object.defineProperty(exports, "deltaForRootInitialization", { enumerable: true, get: function () { return deltaUtil_1.deltaForRootInitialization; } });
Object.defineProperty(exports, "deltaForSet", { enumerable: true, get: function () { return deltaUtil_1.deltaForSet; } });
Object.defineProperty(exports, "emptyFieldChanges", { enumerable: true, get: function () { return deltaUtil_1.emptyFieldChanges; } });
Object.defineProperty(exports, "isEmptyFieldChanges", { enumerable: true, get: function () { return deltaUtil_1.isEmptyFieldChanges; } });
Object.defineProperty(exports, "makeDetachedNodeId", { enumerable: true, get: function () { return deltaUtil_1.makeDetachedNodeId; } });
Object.defineProperty(exports, "offsetDetachId", { enumerable: true, get: function () { return deltaUtil_1.offsetDetachId; } });
Object.defineProperty(exports, "emptyDelta", { enumerable: true, get: function () { return deltaUtil_1.emptyDelta; } });
var detachedFieldIndex_1 = require("./detachedFieldIndex");
Object.defineProperty(exports, "DetachedFieldIndex", { enumerable: true, get: function () { return detachedFieldIndex_1.DetachedFieldIndex; } });
//# sourceMappingURL=index.js.map