/*!
 * Copyright (c) Microsoft Corporation and contributors. All rights reserved.
 * Licensed under the MIT License.
 */
/**
 * This file exists and is package exported to aid in testing of exporting recursive types across package boundaries.
 * Sometimes when TypeScript generates d.ts files, they type check significantly differently than the original source (One example of this: https://github.com/microsoft/TypeScript/issues/20979).
 * Unfortunately our recursive schema types are an example of types that have this kind of issue: the d.ts files tend to get "any" instead of the recursive type reference.
 * Currently we do not have tooling in place to test this in our test suite, and exporting these types here is a temporary crutch to aid in diagnosing this issue.
 */
import { TreeFieldSchema } from "../feature-libraries";
export declare const recursiveObject: import("../feature-libraries").ObjectNodeSchema<"Test Recursive Domain.object", {
    readonly recursive: TreeFieldSchema<import("../feature-libraries").Optional, readonly [() => import("../feature-libraries").ObjectNodeSchema<"Test Recursive Domain.object", any>]>;
    readonly number: import("../feature-libraries").LeafNodeSchema<"com.fluidframework.leaf.number", import("..").ValueSchema.Number>;
}>;
export declare const recursiveObject2: import("../feature-libraries").ObjectNodeSchema<"Test Recursive Domain.object2", {
    readonly recursive: TreeFieldSchema<import("../feature-libraries").Optional, readonly [() => import("../feature-libraries").ObjectNodeSchema<"Test Recursive Domain.object2", any>]>;
    readonly number: TreeFieldSchema<import("../feature-libraries").Optional, readonly [import("../feature-libraries").LeafNodeSchema<"com.fluidframework.leaf.number", import("..").ValueSchema.Number>]>;
}>;
export declare const library: import("../feature-libraries").SchemaLibrary;
//# sourceMappingURL=testRecursiveDomain.d.ts.map