/*!
 * Copyright (c) Microsoft Corporation and contributors. All rights reserved.
 * Licensed under the MIT License.
 */
import { RevisionMetadataSource, TaggedChange } from "../../core";
import { IdAllocator } from "../../util";
import { CrossFieldManager } from "../modular-schema";
import { Changeset } from "./types";
export type NodeChangeInverter<TNodeChange> = (change: TNodeChange) => TNodeChange;
/**
 * Inverts a given changeset.
 * @param change - The changeset to produce the inverse of.
 * @returns The inverse of the given `change` such that the inverse can be applied after `change`.
 *
 * WARNING! This implementation is incomplete:
 * - Support for slices is not implemented.
 */
export declare function invert<TNodeChange>(change: TaggedChange<Changeset<TNodeChange>>, invertChild: NodeChangeInverter<TNodeChange>, genId: IdAllocator, crossFieldManager: CrossFieldManager, revisionMetadata: RevisionMetadataSource): Changeset<TNodeChange>;
//# sourceMappingURL=invert.d.ts.map