"use strict";
/*!
 * Copyright (c) Microsoft Corporation and contributors. All rights reserved.
 * Licensed under the MIT License.
 */
Object.defineProperty(exports, "__esModule", { value: true });
exports.capitalize = exports.disposeSymbol = exports.compareNamed = exports.oneFromSet = exports.invertMap = exports.objectToMap = exports.useAsyncDeterministicStableId = exports.useDeterministicStableId = exports.generateStableId = exports.assertNonNegativeSafeInteger = exports.assertValidRange = exports.assertValidIndex = exports.zipIterables = exports.mapIterable = exports.makeArray = exports.JsonCompatibleReadOnlySchema = exports.isReadonlyArray = exports.isJsonObject = exports.getOrCreate = exports.getOrAddEmptyToMap = exports.fail = exports.compareSets = exports.clone = exports.asMutable = exports.StackyIterator = exports.TransactionResult = exports.OffsetListFactory = exports.nestedSetContains = exports.addToNestedSet = exports.nestedMapFromFlatList = exports.nestedMapToFlatList = exports.tryGetFromNestedMap = exports.tryAddToNestedMap = exports.setInNestedMap = exports.populateNestedMap = exports.SizedNestedMap = exports.forEachInNestedMap = exports.getOrDefaultInNestedMap = exports.getOrAddInNestedMap = exports.getOrAddInMap = exports.deleteFromNestedMap = exports.brandErased = exports.ErasedType = exports.fromErased = exports.extractFromOpaque = exports.brandedStringType = exports.brandedNumberType = exports.brandOpaque = exports.BrandedType = exports.brand = void 0;
exports.fakeIdAllocator = exports.idAllocatorFromState = exports.idAllocatorFromMaxId = exports.setInRangeMap = exports.getFromRangeMap = exports.getFirstEntryFromRangeMap = exports.brandedSlot = exports.getOrCreateSlotContent = exports.ReferenceCountedBase = exports.compareStrings = exports.transformObjectMap = exports.assertValidRangeIndices = void 0;
var brand_1 = require("./brand");
Object.defineProperty(exports, "brand", { enumerable: true, get: function () { return brand_1.brand; } });
Object.defineProperty(exports, "BrandedType", { enumerable: true, get: function () { return brand_1.BrandedType; } });
Object.defineProperty(exports, "brandOpaque", { enumerable: true, get: function () { return brand_1.brandOpaque; } });
Object.defineProperty(exports, "brandedNumberType", { enumerable: true, get: function () { return brand_1.brandedNumberType; } });
Object.defineProperty(exports, "brandedStringType", { enumerable: true, get: function () { return brand_1.brandedStringType; } });
Object.defineProperty(exports, "extractFromOpaque", { enumerable: true, get: function () { return brand_1.extractFromOpaque; } });
Object.defineProperty(exports, "fromErased", { enumerable: true, get: function () { return brand_1.fromErased; } });
Object.defineProperty(exports, "ErasedType", { enumerable: true, get: function () { return brand_1.ErasedType; } });
Object.defineProperty(exports, "brandErased", { enumerable: true, get: function () { return brand_1.brandErased; } });
var nestedMap_1 = require("./nestedMap");
Object.defineProperty(exports, "deleteFromNestedMap", { enumerable: true, get: function () { return nestedMap_1.deleteFromNestedMap; } });
Object.defineProperty(exports, "getOrAddInMap", { enumerable: true, get: function () { return nestedMap_1.getOrAddInMap; } });
Object.defineProperty(exports, "getOrAddInNestedMap", { enumerable: true, get: function () { return nestedMap_1.getOrAddInNestedMap; } });
Object.defineProperty(exports, "getOrDefaultInNestedMap", { enumerable: true, get: function () { return nestedMap_1.getOrDefaultInNestedMap; } });
Object.defineProperty(exports, "forEachInNestedMap", { enumerable: true, get: function () { return nestedMap_1.forEachInNestedMap; } });
Object.defineProperty(exports, "SizedNestedMap", { enumerable: true, get: function () { return nestedMap_1.SizedNestedMap; } });
Object.defineProperty(exports, "populateNestedMap", { enumerable: true, get: function () { return nestedMap_1.populateNestedMap; } });
Object.defineProperty(exports, "setInNestedMap", { enumerable: true, get: function () { return nestedMap_1.setInNestedMap; } });
Object.defineProperty(exports, "tryAddToNestedMap", { enumerable: true, get: function () { return nestedMap_1.tryAddToNestedMap; } });
Object.defineProperty(exports, "tryGetFromNestedMap", { enumerable: true, get: function () { return nestedMap_1.tryGetFromNestedMap; } });
Object.defineProperty(exports, "nestedMapToFlatList", { enumerable: true, get: function () { return nestedMap_1.nestedMapToFlatList; } });
Object.defineProperty(exports, "nestedMapFromFlatList", { enumerable: true, get: function () { return nestedMap_1.nestedMapFromFlatList; } });
var nestedSet_1 = require("./nestedSet");
Object.defineProperty(exports, "addToNestedSet", { enumerable: true, get: function () { return nestedSet_1.addToNestedSet; } });
Object.defineProperty(exports, "nestedSetContains", { enumerable: true, get: function () { return nestedSet_1.nestedSetContains; } });
var offsetList_1 = require("./offsetList");
Object.defineProperty(exports, "OffsetListFactory", { enumerable: true, get: function () { return offsetList_1.OffsetListFactory; } });
var transactionResult_1 = require("./transactionResult");
Object.defineProperty(exports, "TransactionResult", { enumerable: true, get: function () { return transactionResult_1.TransactionResult; } });
var stackyIterator_1 = require("./stackyIterator");
Object.defineProperty(exports, "StackyIterator", { enumerable: true, get: function () { return stackyIterator_1.StackyIterator; } });
var utils_1 = require("./utils");
Object.defineProperty(exports, "asMutable", { enumerable: true, get: function () { return utils_1.asMutable; } });
Object.defineProperty(exports, "clone", { enumerable: true, get: function () { return utils_1.clone; } });
Object.defineProperty(exports, "compareSets", { enumerable: true, get: function () { return utils_1.compareSets; } });
Object.defineProperty(exports, "fail", { enumerable: true, get: function () { return utils_1.fail; } });
Object.defineProperty(exports, "getOrAddEmptyToMap", { enumerable: true, get: function () { return utils_1.getOrAddEmptyToMap; } });
Object.defineProperty(exports, "getOrCreate", { enumerable: true, get: function () { return utils_1.getOrCreate; } });
Object.defineProperty(exports, "isJsonObject", { enumerable: true, get: function () { return utils_1.isJsonObject; } });
Object.defineProperty(exports, "isReadonlyArray", { enumerable: true, get: function () { return utils_1.isReadonlyArray; } });
Object.defineProperty(exports, "JsonCompatibleReadOnlySchema", { enumerable: true, get: function () { return utils_1.JsonCompatibleReadOnlySchema; } });
Object.defineProperty(exports, "makeArray", { enumerable: true, get: function () { return utils_1.makeArray; } });
Object.defineProperty(exports, "mapIterable", { enumerable: true, get: function () { return utils_1.mapIterable; } });
Object.defineProperty(exports, "zipIterables", { enumerable: true, get: function () { return utils_1.zipIterables; } });
Object.defineProperty(exports, "assertValidIndex", { enumerable: true, get: function () { return utils_1.assertValidIndex; } });
Object.defineProperty(exports, "assertValidRange", { enumerable: true, get: function () { return utils_1.assertValidRange; } });
Object.defineProperty(exports, "assertNonNegativeSafeInteger", { enumerable: true, get: function () { return utils_1.assertNonNegativeSafeInteger; } });
Object.defineProperty(exports, "generateStableId", { enumerable: true, get: function () { return utils_1.generateStableId; } });
Object.defineProperty(exports, "useDeterministicStableId", { enumerable: true, get: function () { return utils_1.useDeterministicStableId; } });
Object.defineProperty(exports, "useAsyncDeterministicStableId", { enumerable: true, get: function () { return utils_1.useAsyncDeterministicStableId; } });
Object.defineProperty(exports, "objectToMap", { enumerable: true, get: function () { return utils_1.objectToMap; } });
Object.defineProperty(exports, "invertMap", { enumerable: true, get: function () { return utils_1.invertMap; } });
Object.defineProperty(exports, "oneFromSet", { enumerable: true, get: function () { return utils_1.oneFromSet; } });
Object.defineProperty(exports, "compareNamed", { enumerable: true, get: function () { return utils_1.compareNamed; } });
Object.defineProperty(exports, "disposeSymbol", { enumerable: true, get: function () { return utils_1.disposeSymbol; } });
Object.defineProperty(exports, "capitalize", { enumerable: true, get: function () { return utils_1.capitalize; } });
Object.defineProperty(exports, "assertValidRangeIndices", { enumerable: true, get: function () { return utils_1.assertValidRangeIndices; } });
Object.defineProperty(exports, "transformObjectMap", { enumerable: true, get: function () { return utils_1.transformObjectMap; } });
Object.defineProperty(exports, "compareStrings", { enumerable: true, get: function () { return utils_1.compareStrings; } });
var referenceCounting_1 = require("./referenceCounting");
Object.defineProperty(exports, "ReferenceCountedBase", { enumerable: true, get: function () { return referenceCounting_1.ReferenceCountedBase; } });
var brandedMap_1 = require("./brandedMap");
Object.defineProperty(exports, "getOrCreateSlotContent", { enumerable: true, get: function () { return brandedMap_1.getOrCreateSlotContent; } });
Object.defineProperty(exports, "brandedSlot", { enumerable: true, get: function () { return brandedMap_1.brandedSlot; } });
var rangeMap_1 = require("./rangeMap");
Object.defineProperty(exports, "getFirstEntryFromRangeMap", { enumerable: true, get: function () { return rangeMap_1.getFirstEntryFromRangeMap; } });
Object.defineProperty(exports, "getFromRangeMap", { enumerable: true, get: function () { return rangeMap_1.getFromRangeMap; } });
Object.defineProperty(exports, "setInRangeMap", { enumerable: true, get: function () { return rangeMap_1.setInRangeMap; } });
var idAllocator_1 = require("./idAllocator");
Object.defineProperty(exports, "idAllocatorFromMaxId", { enumerable: true, get: function () { return idAllocator_1.idAllocatorFromMaxId; } });
Object.defineProperty(exports, "idAllocatorFromState", { enumerable: true, get: function () { return idAllocator_1.idAllocatorFromState; } });
Object.defineProperty(exports, "fakeIdAllocator", { enumerable: true, get: function () { return idAllocator_1.fakeIdAllocator; } });
//# sourceMappingURL=index.js.map