/*!
 * Copyright (c) Microsoft Corporation and contributors. All rights reserved.
 * Licensed under the MIT License.
 */
import { type NodeKind as _dummy } from "./schemaTypes";
/**
 * To make API-Extractor happy, the base type has to be exported in addition to the actual schema class.
 * Ideally this would be inlined into the class definition below.
 *
 * TODO:
 * Fix API-Extractor to support class based schema, and remove this workaround (inline this type into `RecursiveObject extends` below).
 * Error: src/class-tree/testRecursiveDomain.ts:32:1 - (ae-forgotten-export) The symbol "RecursiveObject_base" needs to be exported by the entry point index.d.ts
 * See https://github.com/microsoft/rushstack/issues/4429
 * @internal
 */
export declare const base: import("./schemaTypes").TreeNodeSchemaClass<"Test Recursive Domain.testObject", _dummy.Object, object & import("..").TreeNode & import("./schemaTypes").ObjectFromSchemaRecord<{
    readonly recursive: import("./schemaTypes").FieldSchema<import("./schemaTypes").FieldKind.Optional, readonly [() => typeof RecursiveObject]>;
    readonly number: import("./schemaTypes").TreeNodeSchema<"com.fluidframework.leaf.number", _dummy.Leaf, number, number>;
}>, object & import("./schemaTypes").InsertableObjectFromSchemaRecord<{
    readonly recursive: import("./schemaTypes").FieldSchema<import("./schemaTypes").FieldKind.Optional, readonly [() => typeof RecursiveObject]>;
    readonly number: import("./schemaTypes").TreeNodeSchema<"com.fluidframework.leaf.number", _dummy.Leaf, number, number>;
}>, true>;
/**
 * @internal
 */
export declare class RecursiveObject extends base {
}
//# sourceMappingURL=testRecursiveDomain.d.ts.map