/*!
 * Copyright (c) Microsoft Corporation and contributors. All rights reserved.
 * Licensed under the MIT License.
 */
import { ICodecOptions, IJsonCodecWithContext } from "../../codec";
import { FieldKey, ITreeCursorSynchronous } from "../../core";
import { FieldBatchCodec } from "../chunked-forest";
import { Context } from "../chunked-forest/codec/codecs";
import { Format } from "./format";
/**
 * Uses field cursors
 */
export type FieldSet = ReadonlyMap<FieldKey, ITreeCursorSynchronous>;
export type ForestCodec = IJsonCodecWithContext<FieldSet, Format, Format, Context>;
export declare function makeForestSummarizerCodec(options: ICodecOptions, fieldBatchCodec: FieldBatchCodec): ForestCodec;
//# sourceMappingURL=codec.d.ts.map