/*!
 * Copyright (c) Microsoft Corporation and contributors. All rights reserved.
 * Licensed under the MIT License.
 */
import { Static, TSchema } from "@sinclair/typebox";
import { DetachIdOverrideType } from "./types";
declare const CellCount: import("@sinclair/typebox").TNumber;
declare const MoveId: import("@sinclair/typebox").TUnsafe<import("../../core").ChangesetLocalId>;
declare const LineageEvent: import("@sinclair/typebox").TTuple<[import("@sinclair/typebox").TUnsafe<import("../../core").EncodedRevisionTag>, import("@sinclair/typebox").TUnsafe<import("../../core").ChangesetLocalId>, import("@sinclair/typebox").TNumber, import("@sinclair/typebox").TNumber]>;
declare const IdRange: import("@sinclair/typebox").TTuple<[import("@sinclair/typebox").TUnsafe<import("../../core").ChangesetLocalId>, import("@sinclair/typebox").TNumber]>;
declare const CellId: import("@sinclair/typebox").TObject<{
    revision: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TUnsafe<import("../../core").EncodedRevisionTag>>;
    localId: import("@sinclair/typebox").TUnsafe<import("../../core").ChangesetLocalId>;
    adjacentCells: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TArray<import("@sinclair/typebox").TTuple<[import("@sinclair/typebox").TUnsafe<import("../../core").ChangesetLocalId>, import("@sinclair/typebox").TNumber]>>>;
    lineage: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TArray<import("@sinclair/typebox").TTuple<[import("@sinclair/typebox").TUnsafe<import("../../core").EncodedRevisionTag>, import("@sinclair/typebox").TUnsafe<import("../../core").ChangesetLocalId>, import("@sinclair/typebox").TNumber, import("@sinclair/typebox").TNumber]>>>;
}>;
declare const Insert: import("@sinclair/typebox").TObject<{
    id: import("@sinclair/typebox").TUnsafe<import("../../core").ChangesetLocalId>;
    revision: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TUnsafe<import("../../core").EncodedRevisionTag>>;
}>;
declare const MoveIn: import("@sinclair/typebox").TObject<{
    id: import("@sinclair/typebox").TUnsafe<import("../../core").ChangesetLocalId>;
    revision: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TUnsafe<import("../../core").EncodedRevisionTag>>;
    finalEndpoint: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TObject<{
        revision: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TUnsafe<import("../../core").EncodedRevisionTag>>;
        localId: import("@sinclair/typebox").TUnsafe<import("../../core").ChangesetLocalId>;
    }>>;
}>;
declare const Delete: import("@sinclair/typebox").TObject<{
    id: import("@sinclair/typebox").TUnsafe<import("../../core").ChangesetLocalId>;
    revision: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TUnsafe<import("../../core").EncodedRevisionTag>>;
    idOverride: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TObject<{
        type: import("@sinclair/typebox").TEnum<typeof DetachIdOverrideType>;
        id: import("@sinclair/typebox").TObject<{
            revision: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TUnsafe<import("../../core").EncodedRevisionTag>>;
            localId: import("@sinclair/typebox").TUnsafe<import("../../core").ChangesetLocalId>;
            adjacentCells: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TArray<import("@sinclair/typebox").TTuple<[import("@sinclair/typebox").TUnsafe<import("../../core").ChangesetLocalId>, import("@sinclair/typebox").TNumber]>>>;
            lineage: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TArray<import("@sinclair/typebox").TTuple<[import("@sinclair/typebox").TUnsafe<import("../../core").EncodedRevisionTag>, import("@sinclair/typebox").TUnsafe<import("../../core").ChangesetLocalId>, import("@sinclair/typebox").TNumber, import("@sinclair/typebox").TNumber]>>>;
        }>;
    }>>;
}>;
declare const MoveOut: import("@sinclair/typebox").TObject<{
    id: import("@sinclair/typebox").TUnsafe<import("../../core").ChangesetLocalId>;
    revision: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TUnsafe<import("../../core").EncodedRevisionTag>>;
    finalEndpoint: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TObject<{
        revision: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TUnsafe<import("../../core").EncodedRevisionTag>>;
        localId: import("@sinclair/typebox").TUnsafe<import("../../core").ChangesetLocalId>;
    }>>;
    idOverride: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TObject<{
        type: import("@sinclair/typebox").TEnum<typeof DetachIdOverrideType>;
        id: import("@sinclair/typebox").TObject<{
            revision: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TUnsafe<import("../../core").EncodedRevisionTag>>;
            localId: import("@sinclair/typebox").TUnsafe<import("../../core").ChangesetLocalId>;
            adjacentCells: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TArray<import("@sinclair/typebox").TTuple<[import("@sinclair/typebox").TUnsafe<import("../../core").ChangesetLocalId>, import("@sinclair/typebox").TNumber]>>>;
            lineage: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TArray<import("@sinclair/typebox").TTuple<[import("@sinclair/typebox").TUnsafe<import("../../core").EncodedRevisionTag>, import("@sinclair/typebox").TUnsafe<import("../../core").ChangesetLocalId>, import("@sinclair/typebox").TNumber, import("@sinclair/typebox").TNumber]>>>;
        }>;
    }>>;
}>;
declare const Attach: import("@sinclair/typebox").TObject<{
    insert: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TObject<{
        id: import("@sinclair/typebox").TUnsafe<import("../../core").ChangesetLocalId>;
        revision: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TUnsafe<import("../../core").EncodedRevisionTag>>;
    }>>;
    moveIn: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TObject<{
        id: import("@sinclair/typebox").TUnsafe<import("../../core").ChangesetLocalId>;
        revision: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TUnsafe<import("../../core").EncodedRevisionTag>>;
        finalEndpoint: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TObject<{
            revision: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TUnsafe<import("../../core").EncodedRevisionTag>>;
            localId: import("@sinclair/typebox").TUnsafe<import("../../core").ChangesetLocalId>;
        }>>;
    }>>;
}>;
declare const Detach: import("@sinclair/typebox").TObject<{
    delete: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TObject<{
        id: import("@sinclair/typebox").TUnsafe<import("../../core").ChangesetLocalId>;
        revision: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TUnsafe<import("../../core").EncodedRevisionTag>>;
        idOverride: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TObject<{
            type: import("@sinclair/typebox").TEnum<typeof DetachIdOverrideType>;
            id: import("@sinclair/typebox").TObject<{
                revision: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TUnsafe<import("../../core").EncodedRevisionTag>>;
                localId: import("@sinclair/typebox").TUnsafe<import("../../core").ChangesetLocalId>;
                adjacentCells: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TArray<import("@sinclair/typebox").TTuple<[import("@sinclair/typebox").TUnsafe<import("../../core").ChangesetLocalId>, import("@sinclair/typebox").TNumber]>>>;
                lineage: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TArray<import("@sinclair/typebox").TTuple<[import("@sinclair/typebox").TUnsafe<import("../../core").EncodedRevisionTag>, import("@sinclair/typebox").TUnsafe<import("../../core").ChangesetLocalId>, import("@sinclair/typebox").TNumber, import("@sinclair/typebox").TNumber]>>>;
            }>;
        }>>;
    }>>;
    moveOut: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TObject<{
        id: import("@sinclair/typebox").TUnsafe<import("../../core").ChangesetLocalId>;
        revision: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TUnsafe<import("../../core").EncodedRevisionTag>>;
        finalEndpoint: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TObject<{
            revision: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TUnsafe<import("../../core").EncodedRevisionTag>>;
            localId: import("@sinclair/typebox").TUnsafe<import("../../core").ChangesetLocalId>;
        }>>;
        idOverride: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TObject<{
            type: import("@sinclair/typebox").TEnum<typeof DetachIdOverrideType>;
            id: import("@sinclair/typebox").TObject<{
                revision: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TUnsafe<import("../../core").EncodedRevisionTag>>;
                localId: import("@sinclair/typebox").TUnsafe<import("../../core").ChangesetLocalId>;
                adjacentCells: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TArray<import("@sinclair/typebox").TTuple<[import("@sinclair/typebox").TUnsafe<import("../../core").ChangesetLocalId>, import("@sinclair/typebox").TNumber]>>>;
                lineage: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TArray<import("@sinclair/typebox").TTuple<[import("@sinclair/typebox").TUnsafe<import("../../core").EncodedRevisionTag>, import("@sinclair/typebox").TUnsafe<import("../../core").ChangesetLocalId>, import("@sinclair/typebox").TNumber, import("@sinclair/typebox").TNumber]>>>;
            }>;
        }>>;
    }>>;
}>;
declare const AttachAndDetach: import("@sinclair/typebox").TObject<{
    attach: import("@sinclair/typebox").TObject<{
        insert: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TObject<{
            id: import("@sinclair/typebox").TUnsafe<import("../../core").ChangesetLocalId>;
            revision: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TUnsafe<import("../../core").EncodedRevisionTag>>;
        }>>;
        moveIn: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TObject<{
            id: import("@sinclair/typebox").TUnsafe<import("../../core").ChangesetLocalId>;
            revision: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TUnsafe<import("../../core").EncodedRevisionTag>>;
            finalEndpoint: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TObject<{
                revision: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TUnsafe<import("../../core").EncodedRevisionTag>>;
                localId: import("@sinclair/typebox").TUnsafe<import("../../core").ChangesetLocalId>;
            }>>;
        }>>;
    }>;
    detach: import("@sinclair/typebox").TObject<{
        delete: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TObject<{
            id: import("@sinclair/typebox").TUnsafe<import("../../core").ChangesetLocalId>;
            revision: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TUnsafe<import("../../core").EncodedRevisionTag>>;
            idOverride: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TObject<{
                type: import("@sinclair/typebox").TEnum<typeof DetachIdOverrideType>;
                id: import("@sinclair/typebox").TObject<{
                    revision: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TUnsafe<import("../../core").EncodedRevisionTag>>;
                    localId: import("@sinclair/typebox").TUnsafe<import("../../core").ChangesetLocalId>;
                    adjacentCells: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TArray<import("@sinclair/typebox").TTuple<[import("@sinclair/typebox").TUnsafe<import("../../core").ChangesetLocalId>, import("@sinclair/typebox").TNumber]>>>;
                    lineage: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TArray<import("@sinclair/typebox").TTuple<[import("@sinclair/typebox").TUnsafe<import("../../core").EncodedRevisionTag>, import("@sinclair/typebox").TUnsafe<import("../../core").ChangesetLocalId>, import("@sinclair/typebox").TNumber, import("@sinclair/typebox").TNumber]>>>;
                }>;
            }>>;
        }>>;
        moveOut: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TObject<{
            id: import("@sinclair/typebox").TUnsafe<import("../../core").ChangesetLocalId>;
            revision: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TUnsafe<import("../../core").EncodedRevisionTag>>;
            finalEndpoint: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TObject<{
                revision: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TUnsafe<import("../../core").EncodedRevisionTag>>;
                localId: import("@sinclair/typebox").TUnsafe<import("../../core").ChangesetLocalId>;
            }>>;
            idOverride: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TObject<{
                type: import("@sinclair/typebox").TEnum<typeof DetachIdOverrideType>;
                id: import("@sinclair/typebox").TObject<{
                    revision: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TUnsafe<import("../../core").EncodedRevisionTag>>;
                    localId: import("@sinclair/typebox").TUnsafe<import("../../core").ChangesetLocalId>;
                    adjacentCells: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TArray<import("@sinclair/typebox").TTuple<[import("@sinclair/typebox").TUnsafe<import("../../core").ChangesetLocalId>, import("@sinclair/typebox").TNumber]>>>;
                    lineage: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TArray<import("@sinclair/typebox").TTuple<[import("@sinclair/typebox").TUnsafe<import("../../core").EncodedRevisionTag>, import("@sinclair/typebox").TUnsafe<import("../../core").ChangesetLocalId>, import("@sinclair/typebox").TNumber, import("@sinclair/typebox").TNumber]>>>;
                }>;
            }>>;
        }>>;
    }>;
}>;
declare const MarkEffect: import("@sinclair/typebox").TObject<{
    insert: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TObject<{
        id: import("@sinclair/typebox").TUnsafe<import("../../core").ChangesetLocalId>;
        revision: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TUnsafe<import("../../core").EncodedRevisionTag>>;
    }>>;
    moveIn: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TObject<{
        id: import("@sinclair/typebox").TUnsafe<import("../../core").ChangesetLocalId>;
        revision: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TUnsafe<import("../../core").EncodedRevisionTag>>;
        finalEndpoint: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TObject<{
            revision: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TUnsafe<import("../../core").EncodedRevisionTag>>;
            localId: import("@sinclair/typebox").TUnsafe<import("../../core").ChangesetLocalId>;
        }>>;
    }>>;
    delete: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TObject<{
        id: import("@sinclair/typebox").TUnsafe<import("../../core").ChangesetLocalId>;
        revision: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TUnsafe<import("../../core").EncodedRevisionTag>>;
        idOverride: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TObject<{
            type: import("@sinclair/typebox").TEnum<typeof DetachIdOverrideType>;
            id: import("@sinclair/typebox").TObject<{
                revision: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TUnsafe<import("../../core").EncodedRevisionTag>>;
                localId: import("@sinclair/typebox").TUnsafe<import("../../core").ChangesetLocalId>;
                adjacentCells: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TArray<import("@sinclair/typebox").TTuple<[import("@sinclair/typebox").TUnsafe<import("../../core").ChangesetLocalId>, import("@sinclair/typebox").TNumber]>>>;
                lineage: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TArray<import("@sinclair/typebox").TTuple<[import("@sinclair/typebox").TUnsafe<import("../../core").EncodedRevisionTag>, import("@sinclair/typebox").TUnsafe<import("../../core").ChangesetLocalId>, import("@sinclair/typebox").TNumber, import("@sinclair/typebox").TNumber]>>>;
            }>;
        }>>;
    }>>;
    moveOut: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TObject<{
        id: import("@sinclair/typebox").TUnsafe<import("../../core").ChangesetLocalId>;
        revision: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TUnsafe<import("../../core").EncodedRevisionTag>>;
        finalEndpoint: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TObject<{
            revision: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TUnsafe<import("../../core").EncodedRevisionTag>>;
            localId: import("@sinclair/typebox").TUnsafe<import("../../core").ChangesetLocalId>;
        }>>;
        idOverride: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TObject<{
            type: import("@sinclair/typebox").TEnum<typeof DetachIdOverrideType>;
            id: import("@sinclair/typebox").TObject<{
                revision: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TUnsafe<import("../../core").EncodedRevisionTag>>;
                localId: import("@sinclair/typebox").TUnsafe<import("../../core").ChangesetLocalId>;
                adjacentCells: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TArray<import("@sinclair/typebox").TTuple<[import("@sinclair/typebox").TUnsafe<import("../../core").ChangesetLocalId>, import("@sinclair/typebox").TNumber]>>>;
                lineage: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TArray<import("@sinclair/typebox").TTuple<[import("@sinclair/typebox").TUnsafe<import("../../core").EncodedRevisionTag>, import("@sinclair/typebox").TUnsafe<import("../../core").ChangesetLocalId>, import("@sinclair/typebox").TNumber, import("@sinclair/typebox").TNumber]>>>;
            }>;
        }>>;
    }>>;
    attachAndDetach: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TObject<{
        attach: import("@sinclair/typebox").TObject<{
            insert: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TObject<{
                id: import("@sinclair/typebox").TUnsafe<import("../../core").ChangesetLocalId>;
                revision: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TUnsafe<import("../../core").EncodedRevisionTag>>;
            }>>;
            moveIn: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TObject<{
                id: import("@sinclair/typebox").TUnsafe<import("../../core").ChangesetLocalId>;
                revision: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TUnsafe<import("../../core").EncodedRevisionTag>>;
                finalEndpoint: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TObject<{
                    revision: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TUnsafe<import("../../core").EncodedRevisionTag>>;
                    localId: import("@sinclair/typebox").TUnsafe<import("../../core").ChangesetLocalId>;
                }>>;
            }>>;
        }>;
        detach: import("@sinclair/typebox").TObject<{
            delete: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TObject<{
                id: import("@sinclair/typebox").TUnsafe<import("../../core").ChangesetLocalId>;
                revision: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TUnsafe<import("../../core").EncodedRevisionTag>>;
                idOverride: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TObject<{
                    type: import("@sinclair/typebox").TEnum<typeof DetachIdOverrideType>;
                    id: import("@sinclair/typebox").TObject<{
                        revision: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TUnsafe<import("../../core").EncodedRevisionTag>>;
                        localId: import("@sinclair/typebox").TUnsafe<import("../../core").ChangesetLocalId>;
                        adjacentCells: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TArray<import("@sinclair/typebox").TTuple<[import("@sinclair/typebox").TUnsafe<import("../../core").ChangesetLocalId>, import("@sinclair/typebox").TNumber]>>>;
                        lineage: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TArray<import("@sinclair/typebox").TTuple<[import("@sinclair/typebox").TUnsafe<import("../../core").EncodedRevisionTag>, import("@sinclair/typebox").TUnsafe<import("../../core").ChangesetLocalId>, import("@sinclair/typebox").TNumber, import("@sinclair/typebox").TNumber]>>>;
                    }>;
                }>>;
            }>>;
            moveOut: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TObject<{
                id: import("@sinclair/typebox").TUnsafe<import("../../core").ChangesetLocalId>;
                revision: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TUnsafe<import("../../core").EncodedRevisionTag>>;
                finalEndpoint: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TObject<{
                    revision: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TUnsafe<import("../../core").EncodedRevisionTag>>;
                    localId: import("@sinclair/typebox").TUnsafe<import("../../core").ChangesetLocalId>;
                }>>;
                idOverride: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TObject<{
                    type: import("@sinclair/typebox").TEnum<typeof DetachIdOverrideType>;
                    id: import("@sinclair/typebox").TObject<{
                        revision: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TUnsafe<import("../../core").EncodedRevisionTag>>;
                        localId: import("@sinclair/typebox").TUnsafe<import("../../core").ChangesetLocalId>;
                        adjacentCells: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TArray<import("@sinclair/typebox").TTuple<[import("@sinclair/typebox").TUnsafe<import("../../core").ChangesetLocalId>, import("@sinclair/typebox").TNumber]>>>;
                        lineage: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TArray<import("@sinclair/typebox").TTuple<[import("@sinclair/typebox").TUnsafe<import("../../core").EncodedRevisionTag>, import("@sinclair/typebox").TUnsafe<import("../../core").ChangesetLocalId>, import("@sinclair/typebox").TNumber, import("@sinclair/typebox").TNumber]>>>;
                    }>;
                }>>;
            }>>;
        }>;
    }>>;
}>;
declare const CellMark: <TMark extends TSchema, TNodeChange extends TSchema>(tMark: TMark, tNodeChange: TNodeChange) => import("@sinclair/typebox").TObject<{
    effect: import("@sinclair/typebox").TOptional<TMark>;
    cellId: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TObject<{
        revision: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TUnsafe<import("../../core").EncodedRevisionTag>>;
        localId: import("@sinclair/typebox").TUnsafe<import("../../core").ChangesetLocalId>;
        adjacentCells: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TArray<import("@sinclair/typebox").TTuple<[import("@sinclair/typebox").TUnsafe<import("../../core").ChangesetLocalId>, import("@sinclair/typebox").TNumber]>>>;
        lineage: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TArray<import("@sinclair/typebox").TTuple<[import("@sinclair/typebox").TUnsafe<import("../../core").EncodedRevisionTag>, import("@sinclair/typebox").TUnsafe<import("../../core").ChangesetLocalId>, import("@sinclair/typebox").TNumber, import("@sinclair/typebox").TNumber]>>>;
    }>>;
    changes: import("@sinclair/typebox").TOptional<TNodeChange>;
    count: import("@sinclair/typebox").TNumber;
}>;
declare const Mark: <Schema extends TSchema>(tNodeChange: Schema) => import("@sinclair/typebox").TObject<{
    effect: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TObject<{
        insert: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TObject<{
            id: import("@sinclair/typebox").TUnsafe<import("../../core").ChangesetLocalId>;
            revision: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TUnsafe<import("../../core").EncodedRevisionTag>>;
        }>>;
        moveIn: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TObject<{
            id: import("@sinclair/typebox").TUnsafe<import("../../core").ChangesetLocalId>;
            revision: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TUnsafe<import("../../core").EncodedRevisionTag>>;
            finalEndpoint: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TObject<{
                revision: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TUnsafe<import("../../core").EncodedRevisionTag>>;
                localId: import("@sinclair/typebox").TUnsafe<import("../../core").ChangesetLocalId>;
            }>>;
        }>>;
        delete: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TObject<{
            id: import("@sinclair/typebox").TUnsafe<import("../../core").ChangesetLocalId>;
            revision: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TUnsafe<import("../../core").EncodedRevisionTag>>;
            idOverride: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TObject<{
                type: import("@sinclair/typebox").TEnum<typeof DetachIdOverrideType>;
                id: import("@sinclair/typebox").TObject<{
                    revision: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TUnsafe<import("../../core").EncodedRevisionTag>>;
                    localId: import("@sinclair/typebox").TUnsafe<import("../../core").ChangesetLocalId>;
                    adjacentCells: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TArray<import("@sinclair/typebox").TTuple<[import("@sinclair/typebox").TUnsafe<import("../../core").ChangesetLocalId>, import("@sinclair/typebox").TNumber]>>>;
                    lineage: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TArray<import("@sinclair/typebox").TTuple<[import("@sinclair/typebox").TUnsafe<import("../../core").EncodedRevisionTag>, import("@sinclair/typebox").TUnsafe<import("../../core").ChangesetLocalId>, import("@sinclair/typebox").TNumber, import("@sinclair/typebox").TNumber]>>>;
                }>;
            }>>;
        }>>;
        moveOut: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TObject<{
            id: import("@sinclair/typebox").TUnsafe<import("../../core").ChangesetLocalId>;
            revision: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TUnsafe<import("../../core").EncodedRevisionTag>>;
            finalEndpoint: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TObject<{
                revision: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TUnsafe<import("../../core").EncodedRevisionTag>>;
                localId: import("@sinclair/typebox").TUnsafe<import("../../core").ChangesetLocalId>;
            }>>;
            idOverride: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TObject<{
                type: import("@sinclair/typebox").TEnum<typeof DetachIdOverrideType>;
                id: import("@sinclair/typebox").TObject<{
                    revision: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TUnsafe<import("../../core").EncodedRevisionTag>>;
                    localId: import("@sinclair/typebox").TUnsafe<import("../../core").ChangesetLocalId>;
                    adjacentCells: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TArray<import("@sinclair/typebox").TTuple<[import("@sinclair/typebox").TUnsafe<import("../../core").ChangesetLocalId>, import("@sinclair/typebox").TNumber]>>>;
                    lineage: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TArray<import("@sinclair/typebox").TTuple<[import("@sinclair/typebox").TUnsafe<import("../../core").EncodedRevisionTag>, import("@sinclair/typebox").TUnsafe<import("../../core").ChangesetLocalId>, import("@sinclair/typebox").TNumber, import("@sinclair/typebox").TNumber]>>>;
                }>;
            }>>;
        }>>;
        attachAndDetach: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TObject<{
            attach: import("@sinclair/typebox").TObject<{
                insert: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TObject<{
                    id: import("@sinclair/typebox").TUnsafe<import("../../core").ChangesetLocalId>;
                    revision: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TUnsafe<import("../../core").EncodedRevisionTag>>;
                }>>;
                moveIn: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TObject<{
                    id: import("@sinclair/typebox").TUnsafe<import("../../core").ChangesetLocalId>;
                    revision: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TUnsafe<import("../../core").EncodedRevisionTag>>;
                    finalEndpoint: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TObject<{
                        revision: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TUnsafe<import("../../core").EncodedRevisionTag>>;
                        localId: import("@sinclair/typebox").TUnsafe<import("../../core").ChangesetLocalId>;
                    }>>;
                }>>;
            }>;
            detach: import("@sinclair/typebox").TObject<{
                delete: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TObject<{
                    id: import("@sinclair/typebox").TUnsafe<import("../../core").ChangesetLocalId>;
                    revision: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TUnsafe<import("../../core").EncodedRevisionTag>>;
                    idOverride: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TObject<{
                        type: import("@sinclair/typebox").TEnum<typeof DetachIdOverrideType>;
                        id: import("@sinclair/typebox").TObject<{
                            revision: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TUnsafe<import("../../core").EncodedRevisionTag>>;
                            localId: import("@sinclair/typebox").TUnsafe<import("../../core").ChangesetLocalId>;
                            adjacentCells: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TArray<import("@sinclair/typebox").TTuple<[import("@sinclair/typebox").TUnsafe<import("../../core").ChangesetLocalId>, import("@sinclair/typebox").TNumber]>>>;
                            lineage: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TArray<import("@sinclair/typebox").TTuple<[import("@sinclair/typebox").TUnsafe<import("../../core").EncodedRevisionTag>, import("@sinclair/typebox").TUnsafe<import("../../core").ChangesetLocalId>, import("@sinclair/typebox").TNumber, import("@sinclair/typebox").TNumber]>>>;
                        }>;
                    }>>;
                }>>;
                moveOut: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TObject<{
                    id: import("@sinclair/typebox").TUnsafe<import("../../core").ChangesetLocalId>;
                    revision: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TUnsafe<import("../../core").EncodedRevisionTag>>;
                    finalEndpoint: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TObject<{
                        revision: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TUnsafe<import("../../core").EncodedRevisionTag>>;
                        localId: import("@sinclair/typebox").TUnsafe<import("../../core").ChangesetLocalId>;
                    }>>;
                    idOverride: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TObject<{
                        type: import("@sinclair/typebox").TEnum<typeof DetachIdOverrideType>;
                        id: import("@sinclair/typebox").TObject<{
                            revision: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TUnsafe<import("../../core").EncodedRevisionTag>>;
                            localId: import("@sinclair/typebox").TUnsafe<import("../../core").ChangesetLocalId>;
                            adjacentCells: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TArray<import("@sinclair/typebox").TTuple<[import("@sinclair/typebox").TUnsafe<import("../../core").ChangesetLocalId>, import("@sinclair/typebox").TNumber]>>>;
                            lineage: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TArray<import("@sinclair/typebox").TTuple<[import("@sinclair/typebox").TUnsafe<import("../../core").EncodedRevisionTag>, import("@sinclair/typebox").TUnsafe<import("../../core").ChangesetLocalId>, import("@sinclair/typebox").TNumber, import("@sinclair/typebox").TNumber]>>>;
                        }>;
                    }>>;
                }>>;
            }>;
        }>>;
    }>>;
    cellId: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TObject<{
        revision: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TUnsafe<import("../../core").EncodedRevisionTag>>;
        localId: import("@sinclair/typebox").TUnsafe<import("../../core").ChangesetLocalId>;
        adjacentCells: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TArray<import("@sinclair/typebox").TTuple<[import("@sinclair/typebox").TUnsafe<import("../../core").ChangesetLocalId>, import("@sinclair/typebox").TNumber]>>>;
        lineage: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TArray<import("@sinclair/typebox").TTuple<[import("@sinclair/typebox").TUnsafe<import("../../core").EncodedRevisionTag>, import("@sinclair/typebox").TUnsafe<import("../../core").ChangesetLocalId>, import("@sinclair/typebox").TNumber, import("@sinclair/typebox").TNumber]>>>;
    }>>;
    changes: import("@sinclair/typebox").TOptional<Schema>;
    count: import("@sinclair/typebox").TNumber;
}>;
export declare const Changeset: <Schema extends TSchema>(tNodeChange: Schema) => import("@sinclair/typebox").TArray<import("@sinclair/typebox").TObject<{
    effect: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TObject<{
        insert: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TObject<{
            id: import("@sinclair/typebox").TUnsafe<import("../../core").ChangesetLocalId>;
            revision: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TUnsafe<import("../../core").EncodedRevisionTag>>;
        }>>;
        moveIn: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TObject<{
            id: import("@sinclair/typebox").TUnsafe<import("../../core").ChangesetLocalId>;
            revision: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TUnsafe<import("../../core").EncodedRevisionTag>>;
            finalEndpoint: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TObject<{
                revision: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TUnsafe<import("../../core").EncodedRevisionTag>>;
                localId: import("@sinclair/typebox").TUnsafe<import("../../core").ChangesetLocalId>;
            }>>;
        }>>;
        delete: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TObject<{
            id: import("@sinclair/typebox").TUnsafe<import("../../core").ChangesetLocalId>;
            revision: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TUnsafe<import("../../core").EncodedRevisionTag>>;
            idOverride: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TObject<{
                type: import("@sinclair/typebox").TEnum<typeof DetachIdOverrideType>;
                id: import("@sinclair/typebox").TObject<{
                    revision: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TUnsafe<import("../../core").EncodedRevisionTag>>;
                    localId: import("@sinclair/typebox").TUnsafe<import("../../core").ChangesetLocalId>;
                    adjacentCells: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TArray<import("@sinclair/typebox").TTuple<[import("@sinclair/typebox").TUnsafe<import("../../core").ChangesetLocalId>, import("@sinclair/typebox").TNumber]>>>;
                    lineage: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TArray<import("@sinclair/typebox").TTuple<[import("@sinclair/typebox").TUnsafe<import("../../core").EncodedRevisionTag>, import("@sinclair/typebox").TUnsafe<import("../../core").ChangesetLocalId>, import("@sinclair/typebox").TNumber, import("@sinclair/typebox").TNumber]>>>;
                }>;
            }>>;
        }>>;
        moveOut: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TObject<{
            id: import("@sinclair/typebox").TUnsafe<import("../../core").ChangesetLocalId>;
            revision: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TUnsafe<import("../../core").EncodedRevisionTag>>;
            finalEndpoint: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TObject<{
                revision: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TUnsafe<import("../../core").EncodedRevisionTag>>;
                localId: import("@sinclair/typebox").TUnsafe<import("../../core").ChangesetLocalId>;
            }>>;
            idOverride: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TObject<{
                type: import("@sinclair/typebox").TEnum<typeof DetachIdOverrideType>;
                id: import("@sinclair/typebox").TObject<{
                    revision: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TUnsafe<import("../../core").EncodedRevisionTag>>;
                    localId: import("@sinclair/typebox").TUnsafe<import("../../core").ChangesetLocalId>;
                    adjacentCells: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TArray<import("@sinclair/typebox").TTuple<[import("@sinclair/typebox").TUnsafe<import("../../core").ChangesetLocalId>, import("@sinclair/typebox").TNumber]>>>;
                    lineage: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TArray<import("@sinclair/typebox").TTuple<[import("@sinclair/typebox").TUnsafe<import("../../core").EncodedRevisionTag>, import("@sinclair/typebox").TUnsafe<import("../../core").ChangesetLocalId>, import("@sinclair/typebox").TNumber, import("@sinclair/typebox").TNumber]>>>;
                }>;
            }>>;
        }>>;
        attachAndDetach: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TObject<{
            attach: import("@sinclair/typebox").TObject<{
                insert: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TObject<{
                    id: import("@sinclair/typebox").TUnsafe<import("../../core").ChangesetLocalId>;
                    revision: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TUnsafe<import("../../core").EncodedRevisionTag>>;
                }>>;
                moveIn: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TObject<{
                    id: import("@sinclair/typebox").TUnsafe<import("../../core").ChangesetLocalId>;
                    revision: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TUnsafe<import("../../core").EncodedRevisionTag>>;
                    finalEndpoint: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TObject<{
                        revision: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TUnsafe<import("../../core").EncodedRevisionTag>>;
                        localId: import("@sinclair/typebox").TUnsafe<import("../../core").ChangesetLocalId>;
                    }>>;
                }>>;
            }>;
            detach: import("@sinclair/typebox").TObject<{
                delete: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TObject<{
                    id: import("@sinclair/typebox").TUnsafe<import("../../core").ChangesetLocalId>;
                    revision: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TUnsafe<import("../../core").EncodedRevisionTag>>;
                    idOverride: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TObject<{
                        type: import("@sinclair/typebox").TEnum<typeof DetachIdOverrideType>;
                        id: import("@sinclair/typebox").TObject<{
                            revision: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TUnsafe<import("../../core").EncodedRevisionTag>>;
                            localId: import("@sinclair/typebox").TUnsafe<import("../../core").ChangesetLocalId>;
                            adjacentCells: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TArray<import("@sinclair/typebox").TTuple<[import("@sinclair/typebox").TUnsafe<import("../../core").ChangesetLocalId>, import("@sinclair/typebox").TNumber]>>>;
                            lineage: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TArray<import("@sinclair/typebox").TTuple<[import("@sinclair/typebox").TUnsafe<import("../../core").EncodedRevisionTag>, import("@sinclair/typebox").TUnsafe<import("../../core").ChangesetLocalId>, import("@sinclair/typebox").TNumber, import("@sinclair/typebox").TNumber]>>>;
                        }>;
                    }>>;
                }>>;
                moveOut: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TObject<{
                    id: import("@sinclair/typebox").TUnsafe<import("../../core").ChangesetLocalId>;
                    revision: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TUnsafe<import("../../core").EncodedRevisionTag>>;
                    finalEndpoint: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TObject<{
                        revision: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TUnsafe<import("../../core").EncodedRevisionTag>>;
                        localId: import("@sinclair/typebox").TUnsafe<import("../../core").ChangesetLocalId>;
                    }>>;
                    idOverride: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TObject<{
                        type: import("@sinclair/typebox").TEnum<typeof DetachIdOverrideType>;
                        id: import("@sinclair/typebox").TObject<{
                            revision: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TUnsafe<import("../../core").EncodedRevisionTag>>;
                            localId: import("@sinclair/typebox").TUnsafe<import("../../core").ChangesetLocalId>;
                            adjacentCells: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TArray<import("@sinclair/typebox").TTuple<[import("@sinclair/typebox").TUnsafe<import("../../core").ChangesetLocalId>, import("@sinclair/typebox").TNumber]>>>;
                            lineage: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TArray<import("@sinclair/typebox").TTuple<[import("@sinclair/typebox").TUnsafe<import("../../core").EncodedRevisionTag>, import("@sinclair/typebox").TUnsafe<import("../../core").ChangesetLocalId>, import("@sinclair/typebox").TNumber, import("@sinclair/typebox").TNumber]>>>;
                        }>;
                    }>>;
                }>>;
            }>;
        }>>;
    }>>;
    cellId: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TObject<{
        revision: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TUnsafe<import("../../core").EncodedRevisionTag>>;
        localId: import("@sinclair/typebox").TUnsafe<import("../../core").ChangesetLocalId>;
        adjacentCells: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TArray<import("@sinclair/typebox").TTuple<[import("@sinclair/typebox").TUnsafe<import("../../core").ChangesetLocalId>, import("@sinclair/typebox").TNumber]>>>;
        lineage: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TArray<import("@sinclair/typebox").TTuple<[import("@sinclair/typebox").TUnsafe<import("../../core").EncodedRevisionTag>, import("@sinclair/typebox").TUnsafe<import("../../core").ChangesetLocalId>, import("@sinclair/typebox").TNumber, import("@sinclair/typebox").TNumber]>>>;
    }>>;
    changes: import("@sinclair/typebox").TOptional<Schema>;
    count: import("@sinclair/typebox").TNumber;
}>>;
/**
 * @privateRemarks - Many of these names are currently used in the sequence-field types. Putting them in a namespace makes codec code more readable.
 */
export declare namespace Encoded {
    type CellCount = Static<typeof CellCount>;
    type MoveId = Static<typeof MoveId>;
    type LineageEvent = Static<typeof LineageEvent>;
    type IdRange = Static<typeof IdRange>;
    type CellId = Static<typeof CellId>;
    type Insert = Static<typeof Insert>;
    type MoveIn = Static<typeof MoveIn>;
    type Delete = Static<typeof Delete>;
    type MoveOut = Static<typeof MoveOut>;
    type Attach = Static<typeof Attach>;
    type Detach = Static<typeof Detach>;
    type AttachAndDetach = Static<typeof AttachAndDetach>;
    type MarkEffect = Static<typeof MarkEffect>;
    type CellMark<Schema extends TSchema, TNodeChange extends TSchema> = Static<ReturnType<typeof CellMark<Schema, TNodeChange>>>;
    type Mark<Schema extends TSchema> = Static<ReturnType<typeof Mark<Schema>>>;
    type Changeset<Schema extends TSchema> = Static<ReturnType<typeof Changeset<Schema>>>;
}
export {};
//# sourceMappingURL=format.d.ts.map