/*!
 * Copyright (c) Microsoft Corporation and contributors. All rights reserved.
 * Licensed under the MIT License.
 */

export {
	Changeset,
	Delete,
	Detach,
	HasMoveId,
	HasRevisionTag,
	Insert,
	Mark,
	MarkList,
	MoveIn,
	MoveOut,
	NodeChangeType,
	CellCount as NodeCount,
	MoveId,
	Attach,
	NoopMark,
	LineageEvent,
	CellId,
	HasMarkFields,
	HasLineage,
	IdRange,
	CellMark,
	AttachAndDetach,
	DetachIdOverride,
	DetachIdOverrideType,
} from "./types";
export {
	SequenceFieldChangeHandler,
	sequenceFieldChangeHandler,
} from "./sequenceFieldChangeHandler";
export { SequenceChangeRebaser, sequenceFieldChangeRebaser } from "./sequenceFieldChangeRebaser";
export { sequenceFieldChangeCodecFactory } from "./sequenceFieldCodecs";
export { sequenceFieldToDelta, ToDelta } from "./sequenceFieldToDelta";
export { SequenceFieldEditor, sequenceFieldEditor } from "./sequenceFieldEditor";
export { MarkListFactory } from "./markListFactory";
export { NodeChangeRebaser, rebase } from "./rebase";
export { invert, NodeChangeInverter } from "./invert";
export { amendCompose, compose, NodeChangeComposer } from "./compose";
export {
	areComposable,
	areRebasable,
	getInputLength,
	isDetach,
	DetachedNodeTracker,
	newCrossFieldTable,
	newMoveEffectTable,
	CrossFieldTable,
	cloneMark,
	extractMarkEffect,
} from "./utils";
export { isMoveMark, MoveMark, MoveEffectTable, MoveEffect } from "./moveEffectTable";

export { relevantRemovedRoots } from "./relevantRemovedRoots";
